Description

puppet.conf contains the following environment config and a single module exists under /etc/puppet/modules/development:

[development]

    modulepath     = /etc/puppet/modules/development:/etc/puppet/modules/common

 The environment can be listed, but the class can't:

$ curl http://foreman:8443/puppet/environments

["development","production"]

$ curl http://foreman:8443/puppet/environments/development/classes

[]

 The first search with PuppetClass.scan_manifest is always failing, so the first module found isn't getting parsed, only subsequent

modules:

irb -I lib/ -rproxy

irb(main):001:0> Proxy::Puppet::PuppetClass.scan_directory('/etc/puppet/modules/development')

Error while parsing /etc/puppet/modules/development/test/manifests/init.pp: Could not parse for en

vironment production: Error converting value for param 'manifest': Error converting value for para

m 'manifestdir': Could not find value for $confdir

=> []

irb(main):002:0> Proxy::Puppet::PuppetClass.scan_directory('/etc/puppet/modules/development')

=> [#&lt;Proxy::Puppet::PuppetClass:0x7f416cb7e9e0 @params={&quot;foo&quot;=&gt;"fqdn_rand(10, und

ef)"}, @klass="test">]

Associated revisions

Revision d58db757 - 01/20/2013 09:58 AM - Dominic Cleal

fixes #2085 - load Puppet 3 app defaults for master mode too

Allows $confdir and other run mode specific settings to be initialised from

the defaults present in Puppet::Util::RunMode.  When requesting detail on

classes, the Puppet parser indirectly requests app level settings so both

global and app settings are needed.  Refactored into shared code for both

parser and environments to use.

History

#1 - 01/02/2013 01:04 PM - Alexander Litvinenko

Also, when $confdir variable is used in puppet.conf, no environment is available at all - rake puppet:import:puppet_classes RAILS_ENV=production

returns empry array.

Sample string in puppet.conf from Puppet Docs: modulepath = $confdir/environments/$environment/modules:$confdir/modules

http://docs.puppetlabs.com/guides/environment.html

#2 - 01/03/2013 07:06 AM - Dominic Cleal

Alexander Litvinenko wrote:
http://docs.puppetlabs.com/guides/environment.html


Also, when $confdir variable is used in puppet.conf, no environment is available at all - rake puppet:import:puppet_classes

RAILS_ENV=production returns empry array.

Sample string in puppet.conf from Puppet Docs: modulepath = $confdir/environments/$environment/modules:$confdir/modules

 Has this worked for you before?  I just tried Foreman 1.1 with Puppet 2.7.20 and it didn't work, so I'll probably call it a separate bug.

#3 - 01/03/2013 10:36 AM - Alexander Litvinenko

No, it's just not working, and newer works earlier.

#4 - 01/03/2013 10:46 AM - Dominic Cleal

- Status changed from New to Assigned

Thanks - I've filed it as #2099, as it's a little different to the puppet 3 initialisation problem here.

#5 - 01/12/2013 04:47 AM - Dominic Cleal

I'm considering this a blocker for 1.1 and have a proper solution in the works, but here's a quick hack for anybody who wants their proxy to work: 

http://people.redhat.com/~dcleal/2085_puppet3_temp_fix.patch

#6 - 01/17/2013 12:24 PM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/smart-proxy/pull/57

#7 - 01/20/2013 01:23 PM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset d58db7573838c16005113e201833b535af90e6cf.
